/* You do not want to read the code. I can not write C-code. 
   I hate C. Sometimes, I fight a few hours with C, because libs 
   are not available for other languages, and the result of the fight 
   is a code, which is not understandable, but most of the time does,
   what it is expected to do. 
   
   You have been warned. Reading this code could result in desorientation. */

#include <asm/io.h>
#include <linux/mc146818rtc.h>
#include <stdio.h>
#include <math.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>

#define true_slope  12      /* Timerticks for 350, 700 and 1400 us delay */
#define down_slope   5
#define false_slope  4      

int base,rtc;

void hilfe(char *name){
    printf("pioct by Kai Fett, kf@schnism.net. This tool is free for any use.\n\n");
    printf("Syntax: %s PORT DEVICE COMMAND\n\n",name);
    printf("     where PORT    is the # of your lp-Port, 0, 1 or 2\n");
    printf("           DEVICE  is the device you want to control\n");
    printf("           COMMAND is the command you want to be executed\n\n");
    exit(1);
}

void slope(int delay){
  int i;
  unsigned long dummy; 

  ioctl(rtc, RTC_PIE_ON, 0);
  for (i=0;i<delay;i++){
    read(rtc, &dummy, sizeof(unsigned long));
  }
  ioctl(rtc, RTC_PIE_OFF, 0);
}

void down(int delay){outb(3,base);slope(delay);return;}
void up(int delay){outb(2,base);slope(delay);return;}


main(int argc, char *argv[]){
  int value, power;
  char *sdevice=argv[2];
  char *scommand=argv[3];
  char unsigned device=0;
  char unsigned command=0;
  
  if  (argc != 4) {hilfe(argv[0]);}
       
  
 /* if (!strcmp(sdevice,"cd")){device='\xA2';}
  if (!strcmp(scommand,"power")){command='\x1C';} */
  
  if (!strcmp(sdevice,"ld")){device='\xA8';}
  if (!strcmp(sdevice,"tuner")){device='\xA4';}
  if (!strcmp(sdevice,"cd")){device='\xA2';}
  if (!strcmp(sdevice,"tape")){device='\xA1';}
  if (!strcmp(sdevice,"amp")){device='\xA5';}
  if (!strcmp(sdevice,"vcr")){device='\xAB';}

  if (!strcmp(scommand,"power")){command='\x1C';}
  if (!strcmp(scommand,"0")){command='\x00';}
  if (!strcmp(scommand,"1")){command='\x01';}
  if (!strcmp(scommand,"2")){command='\x02';}
  if (!strcmp(scommand,"3")){command='\x03';}
  if (!strcmp(scommand,"4")){command='\x04';}
  if (!strcmp(scommand,"5")){command='\x05';}
  if (!strcmp(scommand,"6")){command='\x06';}
  if (!strcmp(scommand,"7")){command='\x07';}
  if (!strcmp(scommand,"8")){command='\x08';}
  if (!strcmp(scommand,"9")){command='\x09';}
  if (!strcmp(scommand,"levelup")){command='\x0A';}
  if (!strcmp(scommand,"leveldown")){command='\x0B';}
  if (!strcmp(scommand,"mute")){command='\x12';}
  if (!strcmp(scommand,"ffwd")){command='\x10';}
  if (!strcmp(scommand,"rwd")){command='\x11';}
  if (!strcmp(scommand,"stop")){command='\x16';}
  if (!strcmp(scommand,"pause")){command='\x18';}
  if (!strcmp(scommand,"play")){command='\x17';}
  if (!strcmp(scommand,"rec")){command='\x14';}
  if (!strcmp(scommand,"eject")){command='\x51';}
  if (!strcmp(scommand,"pgm")){command='\x0D';}

  
  if ((command == 0) || (device == 0) ) {hilfe(argv[0]);}

  rtc=open("/dev/rtc", O_RDONLY);
  if (rtc == -1){perror("/dev/rtc");exit(1);} 
  ioctl(rtc, RTC_IRQP_SET, 8192);
        
     
  base=0;
  if (*argv[1] == '0'){base=0x3bc;}
  if (*argv[1] == '1'){base=0x378;}
  if (*argv[1] == '2'){base=0x278;}
  if (base == 0){hilfe(argv[0]);}
  if (ioperm(base, 1, 1)) {perror("ioperm"); exit(1);}             
    
  /* Sending the initial sequence */
  down(75);
  up(32);  
  
  /* Now sending 4 packets of 8 bit each: Device, Command, !Device, !Command */
  
  for (power=1;power<129;power=power*2){    
    down(down_slope); if( (device & power) == power) 
    {up(true_slope);} else {up(false_slope);}
  }

  for (power=1;power<129;power=power*2){    
    down(down_slope); if( (device & power) == power) 
    {up(false_slope);} else {up(true_slope);}
  }
  
  for (power=1;power<129;power=power*2){   
    down(down_slope); if( (command & power) == power) 
    {up(true_slope);} else {up(false_slope);}
  }

  for (power=1;power<129;power=power*2){   
    down(down_slope); if( (command & power) == power)
    {up(false_slope);} else {up(true_slope);}
  }  

  down(down_slope);up(5000);
}